//
// File:        InvalidArgumentData.java
// Package:     gov.llnl.babel.cli
// Copyright:   (c) 2005 The Regents of the University of California
// Release:     $Name$
// Revision:    @(#) $Revision: 4618 $
// Date:        $Date: 2005-05-09 15:54:29 -0700 (Mon, 09 May 2005) $
// Description: Exception indicates bad input to command line switch.
// 

package gov.llnl.babel.cli;

/**
 * This exception is thrown by a {@link
 * gov.llnl.babel.cli.CommandLineSwitch} when
 * it receives an argument that's invalid. The message should be designed
 * to be meaningful to an end user.
 */
public class InvalidArgumentException extends Exception { 

  /**
   * Create an exception to indicate to a Babel end user how the
   * command line argument was invalid. If possible, the message
   * should indicate how the argument was wrong. Babel will 
   * write "Babel: Error processing command line switch <em>long form</em>"
   * with a newline where <em>long form</em> is replaced by the 
   * name of the long option before writing the message.
   *
   * @param message a message that will be shown to the Babel
   * end user.
   */
  public InvalidArgumentException(String message)
  {
    super(message);
  }
}
