/*
 * File:        hookstest.c
 * Copyright:   (c) 2004 The Regents of the University of California
 * Revision:    @(#) $Revision: 4533 $
 * Date:        $Date: 2005-04-13 16:38:20 -0700 (Wed, 13 Apr 2005) $
 * Description: Assertion Test C client
 *
 */
#include <stdio.h>
#include "hooks_Basics.h"

#ifndef FALSE
#define FALSE 0
#endif
#ifndef TRUE
#define TRUE 1
#endif

/*************************** main ***************************/
int main(int argc, char**argv)
{ 
  int iVal = 7;
  double dVal = 3.5;
  int32_t part_no = 0;
  static char* hooksFile = "runC.data";
  hooks_Basics h;
  puts("NPARTS 2");

  (void) argc;
  (void) argv;

  hooks_Basics__set_hooks_static(TRUE);

  h = hooks_Basics__create();
  hooks_Basics__set_hooks(h, TRUE);

  /* static method */
  puts("PART 1");
  puts("COMMENT: If it doesn't crash, it passes");
  hooks_Basics_aStaticMeth(dVal);
  puts("RESULT 1 PASS");

  /* non-static method */
  puts("PART 2");
  puts("COMMENT: If it doesn't crash, it passes");
  hooks_Basics_aNonStaticMeth(h, iVal);
  puts("RESULT 2 PASS");

  hooks_Basics_deleteRef(h);
  puts("TEST_RESULT PASS");
  return 0;
}
