/*
 * File:          sort_HeapSort_Impl.c
 * Symbol:        sort.HeapSort-v0.1
 * Symbol Type:   class
 * Babel Version: 0.10.4
 * Description:   Server-side implementation for sort.HeapSort
 * 
 * WARNING: Automatically generated; only changes within splicers preserved
 * 
 * babel-version = 0.10.4
 */

/*
 * DEVELOPERS ARE EXPECTED TO PROVIDE IMPLEMENTATIONS
 * FOR THE FOLLOWING METHODS BETWEEN SPLICER PAIRS.
 */

/*
 * Symbol "sort.HeapSort" (version 0.1)
 * 
 * Heap sort
 */

#include "sort_HeapSort_Impl.h"

#line 26 "../../../../babel/regression/sort/libC/sort_HeapSort_Impl.c"
/* DO-NOT-DELETE splicer.begin(sort.HeapSort._includes) */
#include "sidl_String.h"
#include "sort_Container.h"

static void remakeHeap(sort_Container elem,
                       sort_Comparator comp,
                       sort_Counter cmp,
                       sort_Counter swp,
                       const int32_t last,
                       int32_t first)
{
  const int32_t half = (last >> 1) - 1;
  int32_t child;
  while (first <= half) {
    child = first + first + 1;
    if ((child+1) < last) {
      sort_Counter_inc(cmp);
      if (sort_Container_compare(elem, child, child+1, comp) < 0) ++child;
    }
    sort_Counter_inc(cmp);
    if (sort_Container_compare(elem,first, child,comp) >= 0) break;
    sort_Counter_inc(swp);
    sort_Container_swap(elem, first, child);
    first = child;
  }
}
/* DO-NOT-DELETE splicer.end(sort.HeapSort._includes) */
#line 54 "sort_HeapSort_Impl.c"

/*
 * Static class initializer called exactly once before any user-defined method is dispatched
 */

#undef __FUNC__
#define __FUNC__ "impl_sort_HeapSort__load"

#ifdef __cplusplus
extern "C"
#endif
void
impl_sort_HeapSort__load(
  void)
{
#line 65 "../../../../babel/regression/sort/libC/sort_HeapSort_Impl.c"
  /* DO-NOT-DELETE splicer.begin(sort.HeapSort._load) */
  /* Insert the implementation of the static class initializer method here... */
  /* DO-NOT-DELETE splicer.end(sort.HeapSort._load) */
#line 74 "sort_HeapSort_Impl.c"
}
/*
 * Class constructor called when the class is created.
 */

#undef __FUNC__
#define __FUNC__ "impl_sort_HeapSort__ctor"

#ifdef __cplusplus
extern "C"
#endif
void
impl_sort_HeapSort__ctor(
  /* in */ sort_HeapSort self)
{
#line 80 "../../../../babel/regression/sort/libC/sort_HeapSort_Impl.c"
  /* DO-NOT-DELETE splicer.begin(sort.HeapSort._ctor) */
  /* Insert the implementation of the constructor method here... */
  /* DO-NOT-DELETE splicer.end(sort.HeapSort._ctor) */
#line 94 "sort_HeapSort_Impl.c"
}

/*
 * Class destructor called when the class is deleted.
 */

#undef __FUNC__
#define __FUNC__ "impl_sort_HeapSort__dtor"

#ifdef __cplusplus
extern "C"
#endif
void
impl_sort_HeapSort__dtor(
  /* in */ sort_HeapSort self)
{
#line 96 "../../../../babel/regression/sort/libC/sort_HeapSort_Impl.c"
  /* DO-NOT-DELETE splicer.begin(sort.HeapSort._dtor) */
  /* Insert the implementation of the destructor method here... */
  /* DO-NOT-DELETE splicer.end(sort.HeapSort._dtor) */
#line 115 "sort_HeapSort_Impl.c"
}

/*
 * Sort elements using Heap Sort.
 */

#undef __FUNC__
#define __FUNC__ "impl_sort_HeapSort_sort"

#ifdef __cplusplus
extern "C"
#endif
void
impl_sort_HeapSort_sort(
  /* in */ sort_HeapSort self,
  /* in */ sort_Container elems,
  /* in */ sort_Comparator comp)
{
#line 114 "../../../../babel/regression/sort/libC/sort_HeapSort_Impl.c"
  /* DO-NOT-DELETE splicer.begin(sort.HeapSort.sort) */
  int32_t i;
  const int32_t num = sort_Container_getLength(elems);
  sort_Counter cmp = sort_HeapSort_getCompareCounter(self);
  sort_Counter swp = sort_HeapSort_getSwapCounter(self);
  /* make the heap */
  for(i = ((num/2) - 1); i >= 0; --i) {
    remakeHeap(elems, comp, cmp, swp, num, i);
  }
  /* put top of heap at back and remake the heap */
  i = num - 1;
  while (i > 0) {
    sort_Counter_inc(swp);
    sort_Container_swap(elems, 0, i);
    remakeHeap(elems, comp, cmp, swp, i--, 0);
  }
  sort_Counter_deleteRef(cmp);
  sort_Counter_deleteRef(swp);
  /* DO-NOT-DELETE splicer.end(sort.HeapSort.sort) */
#line 154 "sort_HeapSort_Impl.c"
}

/*
 * Return heap sort.
 */

#undef __FUNC__
#define __FUNC__ "impl_sort_HeapSort_getName"

#ifdef __cplusplus
extern "C"
#endif
char*
impl_sort_HeapSort_getName(
  /* in */ sort_HeapSort self)
{
#line 146 "../../../../babel/regression/sort/libC/sort_HeapSort_Impl.c"
  /* DO-NOT-DELETE splicer.begin(sort.HeapSort.getName) */
  return sidl_String_strdup("Heap sort");
  /* DO-NOT-DELETE splicer.end(sort.HeapSort.getName) */
#line 175 "sort_HeapSort_Impl.c"
}
/* Babel internal methods, Users should not edit below this line. */
struct sort_HeapSort__object* impl_sort_HeapSort_fconnect_sort_HeapSort(char* 
  url, sidl_BaseInterface *_ex) {
  return sort_HeapSort__connect(url, _ex);
}
char * impl_sort_HeapSort_fgetURL_sort_HeapSort(struct sort_HeapSort__object* 
  obj) {
  return sort_HeapSort__getURL(obj);
}
struct sort_SortingAlgorithm__object* 
  impl_sort_HeapSort_fconnect_sort_SortingAlgorithm(char* url,
  sidl_BaseInterface *_ex) {
  return sort_SortingAlgorithm__connect(url, _ex);
}
char * impl_sort_HeapSort_fgetURL_sort_SortingAlgorithm(struct 
  sort_SortingAlgorithm__object* obj) {
  return sort_SortingAlgorithm__getURL(obj);
}
struct sidl_ClassInfo__object* impl_sort_HeapSort_fconnect_sidl_ClassInfo(char* 
  url, sidl_BaseInterface *_ex) {
  return sidl_ClassInfo__connect(url, _ex);
}
char * impl_sort_HeapSort_fgetURL_sidl_ClassInfo(struct sidl_ClassInfo__object* 
  obj) {
  return sidl_ClassInfo__getURL(obj);
}
struct sort_Comparator__object* 
  impl_sort_HeapSort_fconnect_sort_Comparator(char* url,
  sidl_BaseInterface *_ex) {
  return sort_Comparator__connect(url, _ex);
}
char * impl_sort_HeapSort_fgetURL_sort_Comparator(struct 
  sort_Comparator__object* obj) {
  return sort_Comparator__getURL(obj);
}
struct sidl_BaseInterface__object* 
  impl_sort_HeapSort_fconnect_sidl_BaseInterface(char* url,
  sidl_BaseInterface *_ex) {
  return sidl_BaseInterface__connect(url, _ex);
}
char * impl_sort_HeapSort_fgetURL_sidl_BaseInterface(struct 
  sidl_BaseInterface__object* obj) {
  return sidl_BaseInterface__getURL(obj);
}
struct sort_Container__object* impl_sort_HeapSort_fconnect_sort_Container(char* 
  url, sidl_BaseInterface *_ex) {
  return sort_Container__connect(url, _ex);
}
char * impl_sort_HeapSort_fgetURL_sort_Container(struct sort_Container__object* 
  obj) {
  return sort_Container__getURL(obj);
}
struct sort_Counter__object* impl_sort_HeapSort_fconnect_sort_Counter(char* url,
  sidl_BaseInterface *_ex) {
  return sort_Counter__connect(url, _ex);
}
char * impl_sort_HeapSort_fgetURL_sort_Counter(struct sort_Counter__object* 
  obj) {
  return sort_Counter__getURL(obj);
}
struct sidl_BaseClass__object* impl_sort_HeapSort_fconnect_sidl_BaseClass(char* 
  url, sidl_BaseInterface *_ex) {
  return sidl_BaseClass__connect(url, _ex);
}
char * impl_sort_HeapSort_fgetURL_sidl_BaseClass(struct sidl_BaseClass__object* 
  obj) {
  return sidl_BaseClass__getURL(obj);
}
